import 'package:nui_core/data/nui_ent.dart';
import 'package:onesignal_flutter/onesignal_flutter.dart';

class NUIPushMessage extends NUIEnt<NUIPushMessage>{
  NUIPushMessage.empty();
  late int recipientId;
  String? header;
  String? body;
  String? data;
  String? url;
  String? image;
  String? type;
  late bool opened;
  String? actionType;
  String? category;
  String? referenceTitle;
  List<String>? webUrls;
  String? receivedAt;

  @override
  NUIEntMapper<NUIPushMessage> mapper() => NUIPushMessageEntity();
}
class NUIPushMessageEntity extends NUIEntMapper<NUIPushMessage>{
  @override
  String entityName() => "NUIPushMessage";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushMessage>(name: "recipientId", type: NUIEntType.INTEGER, setter: (data, value) => data.recipientId = value, getter: (data) => data.recipientId),
      NUIEntField<NUIPushMessage>(name: "header", type: NUIEntType.STRING, setter: (data, value) => data.header = value, getter: (data) => data.header),
      NUIEntField<NUIPushMessage>(name: "body", type: NUIEntType.STRING, setter: (data, value) => data.body = value, getter: (data) => data.body),
      NUIEntField<NUIPushMessage>(name: "url", type: NUIEntType.STRING, setter: (data, value) => data.url = value, getter: (data) => data.url),
      NUIEntField<NUIPushMessage>(name: "image", type: NUIEntType.STRING, setter: (data, value) => data.image = value, getter: (data) => data.image),
      NUIEntField<NUIPushMessage>(name: "type", type: NUIEntType.STRING, setter: (data, value) => data.type = value, getter: (data) => data.type),
      NUIEntField<NUIPushMessage>(name: "opened", type: NUIEntType.BOOLEAN, setter: (data, value) => data.opened = value, getter: (data) => data.opened),
      NUIEntField<NUIPushMessage>(name: "actionType", type: NUIEntType.STRING, setter: (data, value) => data.actionType = value, getter: (data) => data.actionType),
      NUIEntField<NUIPushMessage>(name: "category", type: NUIEntType.STRING, setter: (data, value) => data.category = value, getter: (data) => data.category),
      NUIEntField<NUIPushMessage>(name: "referenceTitle", type: NUIEntType.STRING, setter: (data, value) => data.referenceTitle = value, getter: (data) => data.referenceTitle),
      NUIEntField<NUIPushMessage>(name: "webUrls", type: NUIEntType.LIST_STRING, setter: (data, value) => data.webUrls = asList<String>(value), getter: (data) => data.webUrls),
      NUIEntField<NUIPushMessage>(name: "receivedAt", type: NUIEntType.STRING, setter: (data, value) => data.receivedAt = value, getter: (data) => data.receivedAt),
    ];
  }

  @override
  NUIPushMessage newInstance() => NUIPushMessage.empty();
}

class NUIRegisterPushDeviceRequest extends NUIEnt<NUIRegisterPushDeviceRequest>{
  NUIRegisterPushDeviceRequest({required this.userId, this.uniqueId, required this.providerDeviceToken, this.deviceModel, this.deviceOs});
  NUIRegisterPushDeviceRequest.empty();
  late String userId;
  String? uniqueId;
  late String providerDeviceToken;
  String? deviceOs;
  String? deviceModel;

  @override
  NUIEntMapper<NUIRegisterPushDeviceRequest> mapper() => NUIRegisterPushDeviceRequestEntity();
}
class NUIRegisterPushDeviceRequestEntity extends NUIEntMapper<NUIRegisterPushDeviceRequest>{
  @override
  String entityName() => "NUIRegisterPushDeviceRequest";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIRegisterPushDeviceRequest>(name: "userId", type: NUIEntType.STRING, setter: (data, value) => data.userId = value, getter: (data) => data.userId),
      NUIEntField<NUIRegisterPushDeviceRequest>(name: "uniqueId", type: NUIEntType.STRING, setter: (data, value) => data.uniqueId = value, getter: (data) => data.uniqueId),
      NUIEntField<NUIRegisterPushDeviceRequest>(name: "providerDeviceToken", type: NUIEntType.STRING, setter: (data, value) => data.providerDeviceToken = value, getter: (data) => data.providerDeviceToken),
      NUIEntField<NUIRegisterPushDeviceRequest>(name: "deviceOs", type: NUIEntType.STRING, setter: (data, value) => data.deviceOs = value, getter: (data) => data.deviceOs),
      NUIEntField<NUIRegisterPushDeviceRequest>(name: "deviceModel", type: NUIEntType.STRING, setter: (data, value) => data.deviceModel = value, getter: (data) => data.deviceModel),
    ];
  }

  @override
  NUIRegisterPushDeviceRequest newInstance() => NUIRegisterPushDeviceRequest.empty();
}

class NUIErrorPlayerIdsResponse extends NUIEnt<NUIErrorPlayerIdsResponse>{
  NUIErrorPlayerIdsResponse.empty();
  List<String>? invalidPlayerIds;
  List<String>? invalidExternalPlayerIds;

  @override
  NUIEntMapper<NUIErrorPlayerIdsResponse> mapper() => NUIErrorPlayerIdsResponseEntity();
}
class NUIErrorPlayerIdsResponseEntity extends NUIEntMapper<NUIErrorPlayerIdsResponse>{
  @override
  String entityName() => "NUIErrorPlayerIdsResponse";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIErrorPlayerIdsResponse>(name: "invalid_player_ids", type: NUIEntType.LIST_STRING, setter: (data, value) => data.invalidPlayerIds = asList<String>(value), getter: (data) => data.invalidPlayerIds),
      NUIEntField<NUIErrorPlayerIdsResponse>(name: "invalid_external_user_ids", type: NUIEntType.LIST_STRING, setter: (data, value) => data.invalidExternalPlayerIds = asList<String>(value), getter: (data) => data.invalidExternalPlayerIds),
    ];
  }

  @override
  NUIErrorPlayerIdsResponse newInstance() => NUIErrorPlayerIdsResponse.empty();
}

class NUIPushOSResponse extends NUIEnt<NUIPushOSResponse>{
  NUIPushOSResponse({this.id, this.recipients, this.errors, this.externalId});
  NUIPushOSResponse.empty();
  String? id;
  int? recipients;
  String? externalId;
  Map<String, dynamic>? errors;

  @override
  NUIEntMapper<NUIPushOSResponse> mapper() => NUIPushOSResponseEntity();
}
class NUIPushOSResponseEntity extends NUIEntMapper<NUIPushOSResponse>{
  @override
  String entityName() => "NUIPushOSResponse";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushOSResponse>(name: "id", type: NUIEntType.STRING, setter: (data, value) => data.id = value, getter: (data) => data.id),
      NUIEntField<NUIPushOSResponse>(name: "recipients", type: NUIEntType.INTEGER, setter: (data, value) => data.recipients = value, getter: (data) => data.recipients),
      NUIEntField<NUIPushOSResponse>(name: "externalId", type: NUIEntType.STRING, setter: (data, value) => data.externalId = value, getter: (data) => data.externalId),
      NUIEntField<NUIPushOSResponse>(name: "errors", type: NUIEntType.MAP, setter: (data, value) => data.errors = value, getter: (data) => data.errors),
    ];
  }

  @override
  NUIPushOSResponse newInstance() => NUIPushOSResponse.empty();
}

class NUIPushOSNotification extends NUIEnt<NUIPushOSNotification>{
  NUIPushOSNotification({
    required this.appId,
    required this.headings,
    required this.contents,
    this.subtitle,
    this.android_channel_id,
    this.huawei_channel_id,
    this.bigPicture,
    this.huawei_big_picture,
    this.data,
    this.includePlayerIds,
    this.includedSegments,
    this.excludedSegments,
  });
  NUIPushOSNotification.empty();
  late String appId;
  late Map<String, String> headings; //en: English
  Map<String, String>? subtitle; //en: English etc
  late Map<String, String> contents;
  String? android_channel_id;
  String? huawei_channel_id;
  String? bigPicture;
  String? huawei_big_picture;
  Map<String, dynamic>? data;
  List<String>? includePlayerIds;
  List<String>? includedSegments;
  List<String>? excludedSegments;

  @override
  NUIEntMapper<NUIPushOSNotification> mapper() => NUIPushOSNotificationEntity();
}
class NUIPushOSNotificationEntity extends NUIEntMapper<NUIPushOSNotification>{
  @override
  String entityName() => "NUIPushOSNotification";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushOSNotification>(name: "appId", type: NUIEntType.STRING, setter: (data, value) => data.appId = value, getter: (data) => data.appId),
      NUIEntField<NUIPushOSNotification>(name: "headings", type: NUIEntType.MAP, setter: (data, value) => data.headings = value, getter: (data) => data.headings),
      NUIEntField<NUIPushOSNotification>(name: "subtitle", type: NUIEntType.MAP, setter: (data, value) => data.subtitle = value, getter: (data) => data.subtitle),
      NUIEntField<NUIPushOSNotification>(name: "contents", type: NUIEntType.MAP, setter: (data, value) => data.contents = value, getter: (data) => data.contents),
      NUIEntField<NUIPushOSNotification>(name: "big_picture", type: NUIEntType.STRING, setter: (data, value) => data.bigPicture = value, getter: (data) => data.bigPicture),
      NUIEntField<NUIPushOSNotification>(name: "huawei_big_picture", type: NUIEntType.STRING, setter: (data, value) => data.huawei_big_picture = value, getter: (data) => data.huawei_big_picture),
      NUIEntField<NUIPushOSNotification>(name: "data", type: NUIEntType.MAP, setter: (data, value) => data.data = value, getter: (data) => data.data),
      NUIEntField<NUIPushOSNotification>(name: "android_channel_id", type: NUIEntType.STRING, setter: (data, value) => data.android_channel_id = value, getter: (data) => data.android_channel_id),
      NUIEntField<NUIPushOSNotification>(name: "huawei_channel_id", type: NUIEntType.STRING, setter: (data, value) => data.huawei_channel_id = value, getter: (data) => data.huawei_channel_id),
      NUIEntField<NUIPushOSNotification>(name: "include_player_ids", type: NUIEntType.LIST_STRING, setter: (data, value) => data.includePlayerIds = asList<String>(value), getter: (data) => data.includePlayerIds),
      NUIEntField<NUIPushOSNotification>(name: "included_segments", type: NUIEntType.LIST_STRING, setter: (data, value) => data.includedSegments = asList<String>(value), getter: (data) => data.includedSegments),
      NUIEntField<NUIPushOSNotification>(name: "excluded_segments", type: NUIEntType.LIST_STRING, setter: (data, value) => data.excludedSegments = asList<String>(value), getter: (data) => data.excludedSegments),

    ];
  }

  @override
  NUIPushOSNotification newInstance() => NUIPushOSNotification.empty();
}

class NUIPushNotification extends NUIEnt<NUIPushNotification>{
  NUIPushNotification({
    this.header,
    this.body,
    this.smallIcon,
    this.largeIcon,
    this.launchUrl,
    this.meta,
    this.data,
    OSNotification? osNotification
  }){
    if(osNotification != null){
      header = osNotification.title ?? "";
      body = osNotification.body ?? "";
      smallIcon = osNotification.smallIcon;
      largeIcon = osNotification.largeIcon;
      launchUrl = osNotification.launchUrl;
      data = osNotification.additionalData ?? Map();

      // get iStudio metadata
      if(osNotification.additionalData?.containsKey("meta") == true){
        final meta = osNotification.additionalData!["meta"];
        this.meta = NUIPushMeta();
        this.meta?.type = meta.optString("type");
        this.meta?.recipientId = meta.optString("recipientId");
        this.meta?.actionType = meta.optString("actionType");
      }
    }
  }

  NUIPushNotification.empty();
  String? header;
  String? body;
  String? smallIcon;
  String? largeIcon;
  String? launchUrl;
  NUIPushMeta? meta;
  Map<String, dynamic>? data;

  @override
  NUIEntMapper<NUIPushNotification> mapper() => NUIPushNotificationEntity();
}
class NUIPushNotificationEntity extends NUIEntMapper<NUIPushNotification>{
  @override
  String entityName() => "NUIPushNotification";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushNotification>(name: "header", type: NUIEntType.STRING, setter: (data, value) => data.header = value, getter: (data) => data.header),
      NUIEntField<NUIPushNotification>(name: "body", type: NUIEntType.STRING, setter: (data, value) => data.body = value, getter: (data) => data.body),
      NUIEntField<NUIPushNotification>(name: "smallIcon", type: NUIEntType.STRING, setter: (data, value) => data.smallIcon = value, getter: (data) => data.smallIcon),
      NUIEntField<NUIPushNotification>(name: "largeIcon", type: NUIEntType.STRING, setter: (data, value) => data.largeIcon = value, getter: (data) => data.largeIcon),
      NUIEntField<NUIPushNotification>(name: "launchUrl", type: NUIEntType.STRING, setter: (data, value) => data.launchUrl = value, getter: (data) => data.launchUrl),
      NUIEntField<NUIPushNotification>(name: "meta", type: NUIEntType.OBJECT, setter: (data, value) => data.meta = asObject<NUIPushMeta>(NUIPushMetaEntity(), value), getter: (data) => data.meta),
      NUIEntField<NUIPushNotification>(name: "data", type: NUIEntType.MAP, setter: (data, value) => data.data = asMap(value), getter: (data) => data.data),
    ];
  }

  @override
  NUIPushNotification newInstance() => NUIPushNotification.empty();
}

class NUIPushMeta extends NUIEnt<NUIPushMeta>{
  NUIPushMeta({this.type, this.recipientId, this.actionType});
  NUIPushMeta.empty();
  String? type;
  String? recipientId;
  String? actionType;

  @override
  NUIEntMapper<NUIPushMeta> mapper() => NUIPushMetaEntity();
}
class NUIPushMetaEntity extends NUIEntMapper<NUIPushMeta>{
  @override
  String entityName() => "NUIPushMeta";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushMeta>(name: "type", type: NUIEntType.STRING, setter: (data, value) => data.type = value, getter: (data) => data.type),
      NUIEntField<NUIPushMeta>(name: "recipientId", type: NUIEntType.STRING, setter: (data, value) => data.recipientId = value, getter: (data) => data.type),
      NUIEntField<NUIPushMeta>(name: "actionType", type: NUIEntType.STRING, setter: (data, value) => data.actionType = value, getter: (data) => data.actionType),
    ];
  }

  @override
  NUIPushMeta newInstance() => NUIPushMeta.empty();
}



class NUIPushInboxMessage extends NUIEnt<NUIPushInboxMessage>{
  NUIPushInboxMessage({
    required this.notificationId,
    required this.notificationDesc,
    required this.notificationTitle,
    this.notificationType,
    this.image,
    required this.notificationDateTime,
    required this.isRead,
    this.itemId});

  NUIPushInboxMessage.empty();
  late String notificationId;
  late String notificationDesc;
  late String notificationTitle;
  String? notificationType;
  String? image;
  late DateTime notificationDateTime;
  String? itemId;
  late bool isRead;

  @override
  NUIEntMapper<NUIPushInboxMessage> mapper() => NUIPushInboxMessageEntity();
}
class NUIPushInboxMessageEntity extends NUIEntMapper<NUIPushInboxMessage>{
  @override
  String entityName() => "NUIPushInboxMessage";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIPushInboxMessage>(name: "id", type: NUIEntType.STRING, setter: (data, value) => data.notificationId = value, getter: (data) => data.notificationId),
      NUIEntField<NUIPushInboxMessage>(name: "notificationTitle", type: NUIEntType.STRING, setter: (data, value) => data.notificationTitle = value, getter: (data) => data.notificationTitle),
      NUIEntField<NUIPushInboxMessage>(name: "notificationDesc", type: NUIEntType.STRING, setter: (data, value) => data.notificationDesc = value, getter: (data) => data.notificationDesc),
      NUIEntField<NUIPushInboxMessage>(name: "notificationType", type: NUIEntType.STRING, setter: (data, value) => data.notificationType = value, getter: (data) => data.notificationType),
      NUIEntField<NUIPushInboxMessage>(name: "notificationDateTime", type: NUIEntType.DATE, setter: (data, value) => data.notificationDateTime = value, getter: (data) => data.notificationDateTime),
      NUIEntField<NUIPushInboxMessage>(name: "image", type: NUIEntType.STRING, setter: (data, value) => data.image = value, getter: (data) => data.image),
      NUIEntField<NUIPushInboxMessage>(name: "isRead", type: NUIEntType.BOOLEAN, setter: (data, value) => data.isRead = value, getter: (data) => data.isRead),

    ];
  }

  @override
  NUIPushInboxMessage newInstance() => NUIPushInboxMessage.empty();
}

typedef DataSetter = dynamic Function(dynamic);

class NUIPushStandardResponse<T> extends NUIEnt<NUIPushStandardResponse<T>>{
  NUIPushStandardResponse(this.dataType, this.dataSetter);
  final NUIEntType dataType;
  final DataSetter dataSetter;

  bool? status;
  String? message;
  String? errorCode;
  T? data;

  @override
  NUIEntMapper<NUIPushStandardResponse<T>> mapper() => NUIPushStandardResponseEnt<T>(dataType, dataSetter);
}

class NUIPushStandardResponseEnt<T> extends NUIEntMapper<NUIPushStandardResponse<T>>{
  NUIPushStandardResponseEnt(this.dataType, this.dataSetter);
  final NUIEntType dataType;
  final DataSetter dataSetter;

  @override
  String entityName() => "NUIPushStandardResponse";

  @override
  List<NUIEntField> fields() {
    return[
      NUIEntField<NUIPushStandardResponse>(name: "status", type: NUIEntType.BOOLEAN, setter: (data, value) => data.status = value, getter: (data) => data.status),
      NUIEntField<NUIPushStandardResponse>(name: "message", type: NUIEntType.STRING, setter: (data, value) => data.message = value, getter: (data) => data.message),
      NUIEntField<NUIPushStandardResponse>(name: "errorCode", type: NUIEntType.STRING, setter: (data, value) => data.errorCode = value, getter: (data) => data.errorCode),
      NUIEntField<NUIPushStandardResponse>(name: "data", type: dataType, setter: (data, value) => data.data = dataSetter(value), getter: (data) => data.data),
    ];
  }

  @override
  NUIPushStandardResponse<T> newInstance() => NUIPushStandardResponse<T>(dataType, dataSetter);
}


class NUINotificationReadPayload extends NUIEnt<NUINotificationReadPayload>{
  NUINotificationReadPayload({required this.notifId, required this.isRead});
  NUINotificationReadPayload.empty();
  late List<String> notifId;
  late bool isRead;

  @override
  NUIEntMapper<NUINotificationReadPayload> mapper() => NUINotificationReadPayloadEntity();
}
class NUINotificationReadPayloadEntity extends NUIEntMapper<NUINotificationReadPayload>{
  @override
  String entityName() => "NUINotificationReadPayload";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUINotificationReadPayload>(name: "notifId", type: NUIEntType.LIST_STRING, setter: (data, value) => data.notifId = asList<String>(value), getter: (data) => data.notifId),
      NUIEntField<NUINotificationReadPayload>(name: "isRead", type: NUIEntType.BOOLEAN, setter: (data, value) => data.isRead = value, getter: (data) => data.isRead),
    ];
  }

  @override
  NUINotificationReadPayload newInstance() => NUINotificationReadPayload.empty();
}



class NUINotificationCountPayload extends NUIEnt<NUINotificationCountPayload>{
  NUINotificationCountPayload({required this.notificationCount});
  NUINotificationCountPayload.empty();
  late int notificationCount;

  @override
  NUIEntMapper<NUINotificationCountPayload> mapper() => NUINotificationCountPayloadEntity();
}
class NUINotificationCountPayloadEntity extends NUIEntMapper<NUINotificationCountPayload>{
  @override
  String entityName() => "NUINotificationCountPayload";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUINotificationCountPayload>(name: "notificationCount", type: NUIEntType.INTEGER, setter: (data, value) => data.notificationCount = value, getter: (data) => data.notificationCount),
    ];
  }

  @override
  NUINotificationCountPayload newInstance() => NUINotificationCountPayload.empty();
}
